%--------------------------------------------
%Nome Jos Nuno Almeida Dias Bueno, 7117308
%SEL0382 - Controle Robusto
%Prof. Vilma Alves de Oliveira
%--------------------------------------------

%Exerccio de aula - Observador de Estado
%Grficos obtidos a partir da simulao

%--------------------------------------------

%Simulao com a lei de realimentao de estado u=-Kx sem observador.
%O vetor "X" contm em cada uma de suas colunas as variveis de estado x1,
%x2 e x3 que correspondem, respectivamente, a theta, theta-ponto e alpha.
%Note que theta  a sada e alpha  a entrada.

close all

x1 = X(:,1);    %x1, ou seja, theta.
x2 = X(:,2);    %x2, ou seja, theta-ponto.
x3 = X(:,3);    %x3, ou seja, alpha.
plot(time, x1, 'b', time, x2, 'r', time, x3, 'g')
title('Simulao para o primeiro conjunto de polos do item 3')
ylabel('Variveis de espao')
xlabel('Tempo, em s')
legend('Theta', 'Theta-ponto', 'Alpha')

%--------------------------------------------

%Simulao com o observador.
%O vetor "Y" contm em cada uma de suas colunas as variveis de estado x1,x2 e x3.
%O vetor "Xchapeu" contm em cada uma de suas colunas as variveis de
%estado estimadas correspondetes respectivamente a x1, x2 e x3.

y1 = Y(:,1);    %x1, ou seja, theta.
y2 = Y(:,2);    %x2, ou seja, theta-ponto.
y3 = Y(:,3);    %x3, ou seja, alpha.
xchapeu1 = Xchapeu(:,1);    %x1chapeu.
xchapeu2 = Xchapeu(:,2);    %x2chapeu.
xchapeu3 = Xchapeu(:,3);    %x3chapeu.

figure(2)
plot(time, y1, 'b', time, xchapeu1, 'r')
ylabel('Theta e theta estimado')
xlabel('Tempo, em s')
legend('Theta', 'Theta estimado')
title('Simulao do sistema com o observador - theta')

figure(3)
plot(time, y2, 'b', time, xchapeu2, 'r')
ylabel('Theta-ponto e theta-ponto estimado')
xlabel('Tempo, em s')
legend('Theta-ponto', 'Theta-ponto estimado')
title('Simulao do sistema com o observador - theta-ponto')

figure(4)
plot(time, y3, 'b', time, xchapeu3, 'r')
ylabel('Alpha e alpha estimado')
xlabel('Tempo, em s')
legend('Alpha', 'Alpha estimado')
title('Simulao do sistema com o observador - alpha')

figure(5)
plot(time, Y3, 'b', time, Y2, 'r')
ylabel('ngulo Theta')
xlabel('Tempo, em s')
legend('Teta estimado', 'Theta estimado + integrador')
title('Simulao do sistema com o observador - Theta')



figure(6)
plot(time, Y3, 'b', time, Y2, 'r')
ylabel('ngulo Theta')
xlabel('Tempo, em s')
legend('Teta com realimentao -ku', 'Theta com realimentao -ku + integrador kI')
title('Simulao do sistema com realimentao -ku +integrador kI ')


